在Elixir Mix Task中以编程方式确定依赖版本。

有什么方法可以在自定义的Mix任务中以编程方式显示已安装的依赖关系的当前版本?

我有一个包,其中包括一些运行一些生成器命令的自定义Mix任务。 我想确定我的hex包的用户正在运行的Phoenix版本,这样我就可以在我的生成器任务中有条件地执行一些逻辑。

我的hex包依赖于Phoenix,但也支持Phoenix 1.3、1.4和最新发布的1.5。

我意识到我可以发布一个新版本的hex包,它有一个固定的依赖凤凰1.5的要求,同时仍然回移植我的包的旧的主要版本的变化;但我宁愿暂时保持一个单一的主线分支,支持尽可能多的版本。

有什么 “体面 “的方法可以做到这一点吗,或者我应该解析一下 mix.lock 我自己在mix任务里面的锁文件? 这样做似乎很脆弱,而且我不认为我的包代码应该到处搜索并解析它所包含的一个更大项目的锁文件。

解决方案:

我还没有针对你的具体要求进行测试,但你也许可以这样做。

app_version =
  Application.spec(:phoenix)[:vsn]
  |> List.to_string()

下面的片段可能也很有用: 如果你有一个模块,但你不知道它所属的atom应用名称。

app_name = Application.get_application(SomeApp)

请看 申请文件 了解更多详情。

希望对大家有所帮助。

给TA打赏
共{{data.count}}人
人已打赏
未分类

为什么SceneKit的CPU使用率这么高?

2022-9-8 6:36:36

未分类

如何在给定的数组中找出和为零的子数组的数量。

2022-9-8 6:36:40

0 条回复 A文章作者 M管理员
    暂无讨论,说说你的看法吧
个人中心
购物车
优惠劵
今日签到
有新私信 私信列表
搜索